package br.gov.mec.linuxeducacional;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.net.URL;

import org.apache.commons.lang.StringUtils;

public abstract class FormController {
	public static void salvarFormulario(FormBean bean) throws Exception {

		try {
			URL url = FormController.class.getResource("/form");
			File file = new File(url.getFile());
			FileWriter fileWriter = new FileWriter(file);
			fileWriter.write(bean.getCodigoInep() + "\n");
			fileWriter.write(bean.getNomeEscola() + "\n");
			fileWriter.write(bean.getMunicipio() + "\n");
			fileWriter.write(bean.getUf() + "\n");
			fileWriter.write(bean.getEndereco() + "\n");
			fileWriter.write(bean.getCoordenadasLatitude() + "\n");
			fileWriter.write(bean.getCoordenadasLongitude() + "\n");
			fileWriter.write(bean.getCep() + "\n");
			fileWriter.write(bean.getResponsavelInformacoes() + "\n");
			fileWriter.write(bean.getDataRecebimento() + "\n");
			fileWriter.write(bean.getCargoFuncao() + "\n");
			fileWriter.write(bean.getTelefone() + "\n");
			fileWriter.write(bean.getEmail() + "\n");
			fileWriter.write(bean.getFax() + "\n");
			fileWriter.write(bean.getNotasFiscais() + "\n");
			fileWriter.write(bean.getNotasDeSimplesRecebimento() + "\n");
			fileWriter.write(bean.isMicrosInstalados09() + "\n");
			fileWriter.write(bean.isRoteadorInstalado() + "\n");
			fileWriter.write(bean.getQuantidadeMicrosInstalados() + "\n");
			fileWriter.write(bean.isTodosMicrosFuncionam() + "\n");
			fileWriter.write(bean.getQuantidadeMicrosDefeito() + "\n");
			fileWriter.write(bean.isImpressoraFunciona() + "\n");
			fileWriter.write(bean.isTodosMicrosImprimem() + "\n");
			fileWriter.write(bean.isVideosOk() + "\n");
			fileWriter.write(bean.isDominioPublicoAcessivel() + "\n");
			fileWriter.write(bean.isDizeresPregao() + "\n");
			fileWriter.write(bean.isTodosPerifericos() + "\n");
			fileWriter.flush();
			fileWriter.close();

		} catch (Exception ex) {
			throw ex;
		}
	}

	public static void salvarArquivoInep(FormBean bean) throws Exception {
		try {
			File file = new File("/etc/ledata");
			FileWriter fileWriter = new FileWriter(file);
			fileWriter.write(bean.getCodigoInep() + "\n");
			fileWriter.write(bean.getUf() + "\n");
			fileWriter.write(bean.getMunicipio() + "\n");
			fileWriter.flush();
			fileWriter.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}

	}

	public static void gerarRelatorio(FormBean bean) throws Exception {
		try {
			URL url = FormController.class.getResource("/doc.rtf");
			File file = new File(url.getFile());
			int fileSize = (int) file.length();
			FileReader reader = new FileReader(file);
			char[] a = new char[fileSize];
			reader.read(a, 0, fileSize);
			String str = new String(a);
			str = StringUtils.replace(str, "_codigoinep", bean.getCodigoInep());
			str = StringUtils.replace(str, "_nomedaescola",
					bean.getNomeEscola());
			str = StringUtils.replace(str, "_municipio", bean.getMunicipio());
			str = StringUtils.replace(str, "_uf", bean.getUf());
			str = StringUtils.replace(str, "_endereco", bean.getEndereco());
			str = StringUtils.replace(str, "_coordlatitude",
					bean.getCoordenadasLatitude());
			str = StringUtils.replace(str, "_coordlongitude",
					bean.getCoordenadasLongitude());
			str = StringUtils.replace(str, "_cep", bean.getCep());
			str = StringUtils.replace(str, "_respinformacoes",
					bean.getResponsavelInformacoes());
			str = StringUtils.replace(str, "_data", bean.getDataRecebimento());
			str = StringUtils.replace(str, "_cargofuncao",
					bean.getCargoFuncao());
			str = StringUtils.replace(str, "_telefone", bean.getTelefone());
			str = StringUtils.replace(str, "_email", bean.getEmail());
			str = StringUtils.replace(str, "_fax", bean.getFax());
			str = StringUtils.replace(str, "_notasfiscais",
					bean.getNotasFiscais());
			str = StringUtils.replace(str, "_notasremessa",
					bean.getNotasDeSimplesRecebimento());
			if (bean.isMicrosInstalados09()) {
				str = StringUtils.replace(str, "_quantidadeinstalados", "10");
			} else {
				str = StringUtils.replace(str, "_quantidadeinstalados",
						bean.getQuantidadeMicrosInstalados());
			}
			if (bean.isRoteadorInstalado()) {
				str = StringUtils.replace(str, "_roteadorinstalado", "Sim");
			} else {
				str = StringUtils.replace(str, "_roteadorinstalado", "Nao");
			}			
			if (bean.isTodosMicrosFuncionam()) {
				str = StringUtils.replace(str, "_todosfuncionamrede", "Sim");
				str = StringUtils.replace(str, "_quantidadedefeito", "");
			} else {
				str = StringUtils.replace(str, "_todosfuncionamrede", "Nao");
				str = StringUtils.replace(str, "_quantidadedefeito", ", "
						+ bean.getQuantidadeMicrosDefeito()
						+ " apresentam defeito.");
			}
			if (bean.isImpressoraFunciona()) {
				str = StringUtils.replace(str, "_impressorafuncionando", "Sim");
			} else {
				str = StringUtils.replace(str, "_impressorafuncionando", "Nao");
			}

			if (bean.isTodosMicrosImprimem()) {
				str = StringUtils.replace(str, "_imprimetodos", "Sim");
			} else {
				str = StringUtils.replace(str, "_imprimetodos", "Nao");
			}

			if (bean.isVideosOk()) {
				str = StringUtils.replace(str, "_videos", "Sim");
			} else {
				str = StringUtils.replace(str, "_videos", "Nao");
			}

			if (bean.isDominioPublicoAcessivel()) {
				str = StringUtils.replace(str, "_dominio", "Sim");
			} else {
				str = StringUtils.replace(str, "_dominio", "Nao");
			}

			if (bean.isDizeresPregao()) {
				str = StringUtils.replace(str, "_pregao", "Sim");
			} else {
				str = StringUtils.replace(str, "_pregao", "Nao");
			}

			if (bean.isTodosPerifericos()) {
				str = StringUtils.replace(str, "_perifericos", "Sim");
			} else {
				str = StringUtils.replace(str, "_perifericos", "Nao");
			}

			File file1 = new File("doc_gerado.rtf");
			FileWriter fileWriter = new FileWriter(file1);
			fileWriter.write(str);
			fileWriter.flush();
			fileWriter.close();
			reader.close();
			Runtime.getRuntime().exec("xdg-open " + file1.getPath());
		} catch (Exception ex) {
			ex.printStackTrace();
		}

	}

	public static FormBean abrirFormulario() throws Exception {
		FormBean bean = new FormBean();
		try {
			URL url = FormController.class.getResource("/form");
			File file = new File(url.getFile());
			BufferedReader reader = new BufferedReader(new FileReader(file));
			bean.setCodigoInep(reader.readLine());
			bean.setNomeEscola(reader.readLine());
			bean.setMunicipio(reader.readLine());
			bean.setUf(reader.readLine());
			bean.setEndereco(reader.readLine());
			bean.setCoordenadasLatitude(reader.readLine());
			bean.setCoordenadasLongitude(reader.readLine());
			bean.setCep(reader.readLine());
			bean.setResponsavelInformacoes(reader.readLine());
			bean.setDataRecebimento(reader.readLine());
			bean.setCargoFuncao(reader.readLine());
			bean.setTelefone(reader.readLine());
			bean.setEmail(reader.readLine());
			bean.setFax(reader.readLine());
			bean.setNotasFiscais(reader.readLine());
			bean.setNotasDeSimplesRecebimento(reader.readLine());
			bean.setMicrosInstalados05(new Boolean(reader.readLine()));
			bean.setRoteadorInstalado(new Boolean(reader.readLine()));			
			bean.setQuantidadeMicrosInstalados(reader.readLine());	
			bean.setTodosMicrosFuncionam(new Boolean(reader.readLine()));
			bean.setQuantidadeMicrosDefeito(reader.readLine());
			bean.setImpressoraFunciona(new Boolean(reader.readLine()));
			bean.setTodosMicrosImprimem(new Boolean(reader.readLine()));
			bean.setVideosOk(new Boolean(reader.readLine()));
			bean.setDominioPublicoAcessivel(new Boolean(reader.readLine()));
			bean.setDizeresPregao(new Boolean(reader.readLine()));
			bean.setTodosPerifericos(new Boolean(reader.readLine()));

		} catch (Exception ex) {
			throw ex;
		}
		return bean;
	}
}
