package br.gov.mec.linuxeducacional;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

public class FormFrame extends JFrame implements ActionListener {

	private static final long serialVersionUID = 1L;

	private GridBagLayout mainLayout;

	private GridBagConstraints c;

	private Container container;

	private JLabel lblCodigoInep;

	private JTextField txtCodigoInep;

	private JLabel lblNomeEscola;

	private JTextField txtNomeEscola;

	private JLabel lblMunicipio;

	private JTextField txtMunicipio;

	private JLabel lblUf;

	private JComboBox cmbUf;

	private JLabel lblCep;

	private JTextField txtCep;

	private JLabel lblEndereco;

	private JTextField txtEndereco;

	private JLabel lblCoordenadasLatitude;

	private JTextField txtCoordenadasLatitude;

	private JLabel lblCoordenadasLongitude;

	private JTextField txtCoordenadasLongitude;

	private JLabel lblNomeResponsavel;

	private JTextField txtNomeResponsavel;

	private JLabel lblDataEntrega;

	private JTextField txtDataEntrega;

	private JLabel lblCargoFuncao;

	private JTextField txtCargoFuncao;

	private JLabel lblTelefone;

	private JTextField txtTelefone;

	private JLabel lblFax;

	private JTextField txtFax;

	private JLabel lblEmail;

	private JTextField txtEmail;

	private JLabel lblNotasFiscais;

	private JTextField txtNotasFiscais;

	private JLabel lblNotasSimplesRemessa;

	private JTextField txtNotasSimplesRemessa;

	private JPanel panelQuantidadeMicrosInstalados;

	private JLabel lblQuantidadeMicrosInstalados;

	private JCheckBox chkQuantidadeMicrosInstalados09;

	private JTextField txtQuantidadeMicrosInstalados;

	private JLabel lblQuantidadeMicrosInstaladosInformar;
	
	private JPanel panelRoteadorInstalado;

	private JLabel lblRoteadorInstalado;

	private JRadioButton radRoteadorInstaladoSim;

	private JRadioButton radRoteadorInstaladoNao;
	
	private ButtonGroup bgrRoteadorInstalado;

	private JPanel panelQuantidadeMicrosRede;

	private JLabel lblQuantidadeMicrosRede;

	private JRadioButton radQuantidadeMicrosRedeSim;

	private JRadioButton radQuantidadeMicrosRedeNao;

	private ButtonGroup bgrQuantidadeMicrosRede;

	private JTextField txtQuantidadeMicrosRedeDefeito;

	private JLabel lblQuantidadeMicrosRedeDefeitoInformar;

	private JPanel panelImpressoraFuncionando;

	private JLabel lblImpressoraFuncionando;

	private JRadioButton radImpressoraFuncionandoSim;

	private JRadioButton radImpressoraFuncionandoNao;

	private ButtonGroup bgrImpressoraFuncionando;

	private JPanel panelImpressoraImprimeTodos;

	private JLabel lblImpressoraImprimeTodos;

	private JRadioButton radImpressoraImprimeTodosSim;

	private JRadioButton radImpressoraImprimeTodosNao;

	private ButtonGroup bgrImpressoraImprimeTodos;

	private JPanel panelVideo;

	private JLabel lblVideo;

	private JRadioButton radVideoSim;

	private JRadioButton radVideoNao;

	private ButtonGroup bgrVideo;

	private JPanel panelDominio;

	private JLabel lblDominio;

	private JRadioButton radDominioSim;

	private JRadioButton radDominioNao;

	private ButtonGroup bgrDominio;

	private JPanel panelPregao;

	private JLabel lblPregao;

	private JRadioButton radPregaoSim;

	private JRadioButton radPregaoNao;

	private ButtonGroup bgrPregao;

	private JPanel panelPeriferico;

	private JLabel lblPeriferico;

	private JRadioButton radPerifericoSim;

	private JRadioButton radPerifericoNao;

	private ButtonGroup bgrPeriferico;

	private JPanel panelBotoes;

	private JButton btnSalvar;

	private JButton btnImprimir;

	private JButton btnFechar;

	public FormFrame() {
		this.setTitle("Termo de Aceitação");
		drawFrame();
		try {
			FormBean bean = FormController.abrirFormulario();
			populateFrame(bean);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	private void drawFrame() {
		container = this.getContentPane();
		mainLayout = new GridBagLayout();
		c = new GridBagConstraints();
		c.insets = new Insets(2, 5, 0, 0);
		c.anchor = GridBagConstraints.WEST;
		container.setLayout(mainLayout);

		lblCodigoInep = new JLabel("Código INEP:");
		c.gridx = 0;
		c.gridy = 0;
		container.add(lblCodigoInep, c);
		txtCodigoInep = new JTextField(15);
		c.gridx = 0;
		c.gridy = 1;
		container.add(txtCodigoInep, c);

		lblNomeEscola = new JLabel("Nome da Escola:");
		c.gridx = 1;
		c.gridy = 0;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(lblNomeEscola, c);
		txtNomeEscola = new JTextField(30);
		c.gridx = 1;
		c.gridy = 1;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(txtNomeEscola, c);
		c.gridwidth = 1;
		lblMunicipio = new JLabel("Município:");
		c.gridx = 0;
		c.gridy = 2;
		container.add(lblMunicipio, c);
		txtMunicipio = new JTextField(15);
		c.gridx = 0;
		c.gridy = 3;
		container.add(txtMunicipio, c);

		lblUf = new JLabel("UF:");
		c.gridx = 1;
		c.gridy = 2;
		container.add(lblUf, c);
		String[] ufs = { "Acre", "Alagoas", "Amapá", "Amazonas", "Bahia",
				"Ceará", "Distrito Federal", "Espírito Santo", "Goiás",
				"Maranhão", "Mato Grosso", "Mato Grosso do Sul",
				"Minas Gerais", "Pará", "Paraíba", "Paraná", "Pernambuco",
				"Piauí", "Rio de Janeiro", "Rio Grande do Norte",
				"Rio Grande do Sul", "Rondônia", "Roraima", "Santa Catarina",
				"São Paulo", "Sergipe", "Tocantins" };
		cmbUf = new JComboBox(ufs);
		c.gridx = 1;
		c.gridy = 3;
		container.add(cmbUf, c);

		lblCep = new JLabel("Cep:");
		c.gridx = 2;
		c.gridy = 2;
		container.add(lblCep, c);
		txtCep = new JTextField(12);
		c.gridx = 2;
		c.gridy = 3;
		container.add(txtCep, c);

		lblEndereco = new JLabel("Endereço:");
		c.gridx = 0;
		c.gridy = 4;
		container.add(lblEndereco, c);
		txtEndereco = new JTextField(50);
		c.gridx = 0;
		c.gridy = 5;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(txtEndereco, c);

		lblCoordenadasLatitude = new JLabel("Latitude:");
		c.gridx = 0;
		c.gridy = 6;
		container.add(lblCoordenadasLatitude, c);
		txtCoordenadasLatitude = new JTextField(12);
		c.gridx = 0;
		c.gridy = 7;
		container.add(txtCoordenadasLatitude, c);

		lblCoordenadasLongitude = new JLabel("Longitude:");
		c.gridx = 1;
		c.gridy = 6;
		container.add(lblCoordenadasLongitude, c);
		txtCoordenadasLongitude = new JTextField(12);
		c.gridx = 1;
		c.gridy = 7;
		container.add(txtCoordenadasLongitude, c);

		lblNomeResponsavel = new JLabel("Resp. Informações");
		c.gridx = 0;
		c.gridy = 8;
		container.add(lblNomeResponsavel, c);
		txtNomeResponsavel = new JTextField(15);
		c.gridx = 0;
		c.gridy = 9;
		container.add(txtNomeResponsavel, c);

		lblDataEntrega = new JLabel("Em:");
		c.gridx = 1;
		c.gridy = 8;
		container.add(lblDataEntrega, c);
		txtDataEntrega = new JTextField(10);
		c.gridx = 1;
		c.gridy = 9;
		container.add(txtDataEntrega, c);

		lblCargoFuncao = new JLabel("Cargo / Função");
		c.gridx = 0;
		c.gridy = 10;
		container.add(lblCargoFuncao, c);
		txtCargoFuncao = new JTextField(15);
		c.gridx = 0;
		c.gridy = 11;
		container.add(txtCargoFuncao, c);

		lblTelefone = new JLabel("Telefone:");
		c.gridx = 1;
		c.gridy = 10;
		container.add(lblTelefone, c);
		txtTelefone = new JTextField(10);
		c.gridx = 1;
		c.gridy = 11;
		container.add(txtTelefone, c);

		lblEmail = new JLabel("E-mail:");
		c.gridx = 0;
		c.gridy = 12;
		container.add(lblEmail, c);
		txtEmail = new JTextField(15);
		c.gridx = 0;
		c.gridy = 13;
		container.add(txtEmail, c);

		lblFax = new JLabel("Fax:");
		c.gridx = 1;
		c.gridy = 12;
		container.add(lblFax, c);
		txtFax = new JTextField(10);
		c.gridx = 1;
		c.gridy = 13;
		container.add(txtFax, c);

		lblNotasFiscais = new JLabel("Notas Fiscais:");
		c.gridx = 0;
		c.gridy = 14;
		container.add(lblNotasFiscais, c);
		txtNotasFiscais = new JTextField(15);
		c.gridx = 0;
		c.gridy = 15;
		container.add(txtNotasFiscais, c);

		lblNotasSimplesRemessa = new JLabel("Notas de Simples Remessa:");
		c.gridx = 1;
		c.gridy = 14;
		container.add(lblNotasSimplesRemessa, c);
		txtNotasSimplesRemessa = new JTextField(15);
		c.gridx = 1;
		c.gridy = 15;
		container.add(txtNotasSimplesRemessa, c);

		panelQuantidadeMicrosInstalados = new JPanel();
		lblQuantidadeMicrosInstalados = new JLabel(
				"1.1) Quantidade de Microcomputadores instalados.");
		chkQuantidadeMicrosInstalados09 = new JCheckBox("10");
		txtQuantidadeMicrosInstalados = new JTextField(2);
		lblQuantidadeMicrosInstaladosInformar = new JLabel(
				"(informar quantidade)");
		panelQuantidadeMicrosInstalados.add(lblQuantidadeMicrosInstalados);
		panelQuantidadeMicrosInstalados.add(chkQuantidadeMicrosInstalados09);
		panelQuantidadeMicrosInstalados.add(txtQuantidadeMicrosInstalados);
		panelQuantidadeMicrosInstalados
				.add(lblQuantidadeMicrosInstaladosInformar);
		c.gridx = 0;
		c.gridy = 16;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(panelQuantidadeMicrosInstalados, c);

		panelRoteadorInstalado = new JPanel();
		lblRoteadorInstalado = new JLabel(
				"1.2) O roteador está instalado?");
		bgrRoteadorInstalado = new ButtonGroup();
		radRoteadorInstaladoSim = new JRadioButton("Sim");
		bgrRoteadorInstalado.add(radRoteadorInstaladoSim);
		radRoteadorInstaladoNao = new JRadioButton("Não");
		bgrRoteadorInstalado.add(radRoteadorInstaladoNao);
		panelRoteadorInstalado.add(lblRoteadorInstalado);
		panelRoteadorInstalado.add(radRoteadorInstaladoSim);
		panelRoteadorInstalado.add(radRoteadorInstaladoNao);
		c.gridx = 0;
		c.gridy = 17;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(panelRoteadorInstalado, c);		
				
		panelQuantidadeMicrosRede = new JPanel();
		lblQuantidadeMicrosRede = new JLabel(
				"1.3) Todos os computadores instalados funcionam em rede?");
		bgrQuantidadeMicrosRede = new ButtonGroup();
		radQuantidadeMicrosRedeSim = new JRadioButton("Sim");
		bgrQuantidadeMicrosRede.add(radQuantidadeMicrosRedeSim);
		radQuantidadeMicrosRedeNao = new JRadioButton("Não");
		bgrQuantidadeMicrosRede.add(radQuantidadeMicrosRedeNao);
		txtQuantidadeMicrosRedeDefeito = new JTextField(2);
		lblQuantidadeMicrosRedeDefeitoInformar = new JLabel(
				"(informar quantidade defeituosa)");
		panelQuantidadeMicrosRede.add(lblQuantidadeMicrosRede);
		panelQuantidadeMicrosRede.add(radQuantidadeMicrosRedeSim);
		panelQuantidadeMicrosRede.add(radQuantidadeMicrosRedeNao);
		panelQuantidadeMicrosRede.add(txtQuantidadeMicrosRedeDefeito);
		panelQuantidadeMicrosRede.add(lblQuantidadeMicrosRedeDefeitoInformar);
		c.gridx = 0;
		c.gridy = 18;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(panelQuantidadeMicrosRede, c);

		panelImpressoraFuncionando = new JPanel();
		lblImpressoraFuncionando = new JLabel(
				"1.4) A impressora está funcionando?");
		bgrImpressoraFuncionando = new ButtonGroup();
		radImpressoraFuncionandoSim = new JRadioButton("Sim");
		bgrImpressoraFuncionando.add(radImpressoraFuncionandoSim);
		radImpressoraFuncionandoNao = new JRadioButton("Não");
		bgrImpressoraFuncionando.add(radImpressoraFuncionandoNao);
		panelImpressoraFuncionando.add(lblImpressoraFuncionando);
		panelImpressoraFuncionando.add(radImpressoraFuncionandoSim);
		panelImpressoraFuncionando.add(radImpressoraFuncionandoNao);
		c.gridx = 0;
		c.gridy = 19;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(panelImpressoraFuncionando, c);

		panelImpressoraImprimeTodos = new JPanel();
		lblImpressoraImprimeTodos = new JLabel(
				"1.5) A impressora imprime de qualquer um dos computadores, pela rede?");
		bgrImpressoraImprimeTodos = new ButtonGroup();
		radImpressoraImprimeTodosSim = new JRadioButton("Sim");
		bgrImpressoraImprimeTodos.add(radImpressoraImprimeTodosSim);
		radImpressoraImprimeTodosNao = new JRadioButton("Não");
		bgrImpressoraImprimeTodos.add(radImpressoraImprimeTodosNao);
		panelImpressoraImprimeTodos.add(lblImpressoraImprimeTodos);
		panelImpressoraImprimeTodos.add(radImpressoraImprimeTodosSim);
		panelImpressoraImprimeTodos.add(radImpressoraImprimeTodosNao);
		c.gridx = 0;
		c.gridy = 20;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(panelImpressoraImprimeTodos, c);

		panelVideo = new JPanel();
		lblVideo = new JLabel(
				"1.6) Os vídeos estão tocando normalmente e com som?");
		bgrVideo = new ButtonGroup();
		radVideoSim = new JRadioButton("Sim");
		bgrVideo.add(radVideoSim);
		radVideoNao = new JRadioButton("Não");
		bgrVideo.add(radVideoNao);
		panelVideo.add(lblVideo);
		panelVideo.add(radVideoSim);
		panelVideo.add(radVideoNao);
		c.gridx = 0;
		c.gridy = 21;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(panelVideo, c);

		panelDominio = new JPanel();
		lblDominio = new JLabel(
				"1.7) Os arquivos do Domínio Público estão acessíveis?");
		bgrDominio = new ButtonGroup();
		radDominioSim = new JRadioButton("Sim");
		bgrDominio.add(radDominioSim);
		radDominioNao = new JRadioButton("Não");
		bgrDominio.add(radDominioNao);
		panelDominio.add(lblDominio);
		panelDominio.add(radDominioSim);
		panelDominio.add(radDominioNao);
		c.gridx = 0;
		c.gridy = 22;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(panelDominio, c);

		panelPregao = new JPanel();
		lblPregao = new JLabel(
				"1.8) Todos os gabinetes possuem os dizeres: MEC/FNDE - Proinfo Urbano - FNDE Pregão: 23/2012?");
		bgrPregao = new ButtonGroup();
		radPregaoSim = new JRadioButton("Sim");
		bgrPregao.add(radPregaoSim);
		radPregaoNao = new JRadioButton("Não");
		bgrPregao.add(radPregaoNao);
		panelPregao.add(lblPregao);
		panelPregao.add(radPregaoSim);
		panelPregao.add(radPregaoNao);
		c.gridx = 0;
		c.gridy = 23;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(panelPregao, c);

		panelPeriferico = new JPanel();
		lblPeriferico = new JLabel(
				"1.9) Todos os computadores estão com mouse, teclado e fones de ouvido disponíveis e funcionais?");
		bgrPeriferico = new ButtonGroup();
		radPerifericoSim = new JRadioButton("Sim");
		bgrPeriferico.add(radPerifericoSim);
		radPerifericoNao = new JRadioButton("Não");
		bgrPeriferico.add(radPerifericoNao);
		panelPeriferico.add(lblPeriferico);
		panelPeriferico.add(radPerifericoSim);
		panelPeriferico.add(radPerifericoNao);
		c.gridx = 0;
		c.gridy = 24;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(panelPeriferico, c);

		panelBotoes = new JPanel();
		btnSalvar = new JButton("Salvar");
		btnSalvar.setActionCommand("salvar");
		btnSalvar.addActionListener(this);
		btnImprimir = new JButton("Gerar Relatório para Impressão");
		btnImprimir.setActionCommand("imprimir");
		btnImprimir.addActionListener(this);
		btnFechar = new JButton("Fechar");
		btnFechar.setActionCommand("fechar");
		btnFechar.addActionListener(this);
		panelBotoes.add(btnSalvar);
		panelBotoes.add(btnImprimir);
		panelBotoes.add(btnFechar);
		c.gridx = 0;
		c.gridy = 25;
		c.gridwidth = GridBagConstraints.REMAINDER;
		container.add(panelBotoes, c);

	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equals("salvar")) {
			try {
				FormBean bean = createBean();
				FormController.salvarFormulario(bean);
				FormController.salvarArquivoInep(bean);
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		} else if (e.getActionCommand().equals("fechar")) {
			System.exit(0);
		} else if (e.getActionCommand().equals("imprimir")) {
			try {
				FormBean bean = createBean();
				FormController.gerarRelatorio(bean);
				FormController.salvarArquivoInep(bean);
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}

	}

	private FormBean createBean() {
		FormBean bean = new FormBean();
		bean.setCodigoInep(txtCodigoInep.getText());
		bean.setNomeEscola(txtNomeEscola.getText());
		bean.setMunicipio(txtMunicipio.getText());
		bean.setUf((String) cmbUf.getSelectedItem());
		bean.setEndereco(txtEndereco.getText());
		bean.setCoordenadasLatitude(txtCoordenadasLatitude.getText());
		bean.setCoordenadasLongitude(txtCoordenadasLongitude.getText());
		bean.setCep(txtCep.getText());
		bean.setResponsavelInformacoes(txtNomeResponsavel.getText());
		bean.setDataRecebimento(txtDataEntrega.getText());
		bean.setCargoFuncao(txtCargoFuncao.getText());
		bean.setTelefone(txtTelefone.getText());
		bean.setEmail(txtEmail.getText());
		bean.setFax(txtFax.getText());
		bean.setNotasFiscais(txtNotasFiscais.getText());
		bean.setNotasDeSimplesRecebimento(txtNotasSimplesRemessa.getText());
		bean.setMicrosInstalados05(chkQuantidadeMicrosInstalados09.isSelected());
		bean.setRoteadorInstalado(radRoteadorInstaladoSim.isSelected());
		bean.setQuantidadeMicrosInstalados(txtQuantidadeMicrosInstalados
				.getText());
		bean.setQuantidadeMicrosDefeito(txtQuantidadeMicrosRedeDefeito
				.getText());
		bean.setTodosMicrosFuncionam(radQuantidadeMicrosRedeSim.isSelected());
		bean.setImpressoraFunciona(radImpressoraFuncionandoSim.isSelected());
		bean.setTodosMicrosImprimem(radImpressoraImprimeTodosSim.isSelected());
		bean.setVideosOk(radVideoSim.isSelected());
		bean.setDominioPublicoAcessivel(radDominioSim.isSelected());
		bean.setDizeresPregao(radPregaoSim.isSelected());
		bean.setTodosPerifericos(radPerifericoSim.isSelected());
		return bean;

	}

	private void populateFrame(FormBean bean) {
		txtCodigoInep.setText(bean.getCodigoInep());
		txtNomeEscola.setText(bean.getNomeEscola());
		txtMunicipio.setText(bean.getMunicipio());
		cmbUf.setSelectedItem(bean.getUf());
		txtEndereco.setText(bean.getEndereco());
		txtCoordenadasLatitude.setText(bean.getCoordenadasLatitude());
		txtCoordenadasLongitude.setText(bean.getCoordenadasLongitude());
		txtCep.setText(bean.getCep());
		txtNomeResponsavel.setText(bean.getResponsavelInformacoes());
		txtDataEntrega.setText(bean.getDataRecebimento());
		txtCargoFuncao.setText(bean.getCargoFuncao());
		txtTelefone.setText(bean.getTelefone());
		txtEmail.setText(bean.getEmail());
		txtFax.setText(bean.getFax());
		txtNotasFiscais.setText(bean.getNotasFiscais());
		txtNotasSimplesRemessa.setText(bean.getNotasDeSimplesRecebimento());
		if (bean.isMicrosInstalados09()) {
			chkQuantidadeMicrosInstalados09.setSelected(true);
		} else {
			txtQuantidadeMicrosInstalados.setText(bean
					.getQuantidadeMicrosInstalados());
		}
		if (bean.isTodosMicrosFuncionam()) {
			radQuantidadeMicrosRedeSim.setSelected(true);
		} else {
			radQuantidadeMicrosRedeNao.setSelected(true);
		}
		txtQuantidadeMicrosRedeDefeito.setText(bean
				.getQuantidadeMicrosDefeito());

		if (bean.isRoteadorInstalado()) {
			radRoteadorInstaladoSim.setSelected(true);
		} else {
			radRoteadorInstaladoNao.setSelected(true);
		}		
		
		if (bean.isImpressoraFunciona()) {
			radImpressoraFuncionandoSim.setSelected(true);
		} else {
			radImpressoraFuncionandoNao.setSelected(true);
		}

		if (bean.isTodosMicrosImprimem()) {
			radImpressoraImprimeTodosSim.setSelected(true);
		} else {
			radImpressoraImprimeTodosNao.setSelected(true);
		}

		if (bean.isVideosOk()) {
			radVideoSim.setSelected(true);
		} else {
			radVideoNao.setSelected(true);
		}

		if (bean.isDominioPublicoAcessivel()) {
			radDominioSim.setSelected(true);
		} else {
			radDominioNao.setSelected(true);
		}

		if (bean.isDizeresPregao()) {
			radPregaoSim.setSelected(true);
		} else {
			radPregaoNao.setSelected(true);
		}

		if (bean.isTodosPerifericos()) {
			radPerifericoSim.setSelected(true);
		} else {
			radPerifericoNao.setSelected(true);
		}

	}
}
